// debug alerts through # 0

var epitopia_url_base = "http://epitopia.bioinfo.tau.ac.il";
var epitopia_url_results = epitopia_url_base + "/epitopia/results/";

var ep_not_solv_exp_count;
var ep_non_sel_chains_aa_count;

// = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
// DESIGN NOTES:

// ALL ARRAYS' first occupied position is 1, not 0.
//		(except for rare ones generated with .split())

// = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function setup_epitopia()
{
	// initialize relevant consurf variables
	consurf_pdb_id = epitopia_pdb_id;
//	consurf_chain = epitopia_chain;

	consurf_grade_freqs = epitopia_grade_freqs;

	identical_chains_reported = false;

	ep_not_solv_exp_count = -1; // undefined
	if (typeof(epitopia_not_solvent_exposed_residue_count) != "undefined")
		ep_not_solv_exp_count = epitopia_not_solvent_exposed_residue_count;

	ep_non_sel_chains_aa_count = -1; // undefined
	if (typeof(epitopia_non_selected_chains_residue_count) != "undefined")
		ep_non_sel_chains_aa_count = epitopia_non_selected_chains_residue_count;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
/*
function epitopiaChainToggle(ci, mode)
{
	var cic = Clist.charAt(ci);
	var cts = "select :" + cic + ";\n";
		
	if (mode)
		cts += "spacefill;\n";
	else
	{
		if (consurf_chain_display_mode == "cartoon")
			cts += "backbone off; cartoon;\n";
		else // "none" for backbone, "all" for all spacefilled
			cts += "cartoon off; backbone 0.4;\n";
		cts += "spacefill off;\n";
	}
	do_spt(cts);

	consurf_chain_checkbox[ci] = mode;
}
*/
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function epitopiaChainFind(ci)
{
	var cic = Clist.charAt(ci);
	var cts = "select :" + cic + ";\n";
		
	cts += "set display selected;\n";

	unchangedScriptToJmol(cts);

}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function epitopiaChainClear()
{
	unchangedScriptToJmol("set display normal;\n");
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
